package
{
	import flash.events.*;
	import flash.net.Socket;
	import flash.system.Security;
	import flash.utils.Dictionary;
	
	public class MySocket extends EventDispatcher
	{
		public var socket:Socket = null;
		
		public var users:Dictionary = new Dictionary;
		
		static public var SERVER_MSG:String = "server_data_msg";
		static public var CONNECTED_TO_SERVER:String = "connected_to_server";
		static public var CONNECTION_ERROR:String = "connection error";
		static public var DISCONNECTED:String = "disconnected";
		
		public var ready:Boolean = false;
		
		public var first_message:String = "hola!";
		
		public function MySocket()
		{
		}
		
		public function allowServer(server_host:String):void
		{
			//Security.allowDomain("*");
        	//trace("Loading policies from:",server_host + "/crossdomain.xml");
        	//Security.loadPolicyFile("http://" + server_host + "/crossdomain.xml");
        	//Security.
        	//Security.allowDomain(server_host);
		}
		
		public function connect(host:String, port:int):void
		{
			//allowServer(host);
			
			try
			{ 
				socket = new flash.net.Socket(host,port);
				socket.addEventListener(Event.CONNECT, onConnect);
				socket.addEventListener(Event.CLOSE, onClose);
				socket.addEventListener(IOErrorEvent.IO_ERROR, onError);
				socket.addEventListener(ProgressEvent.SOCKET_DATA, onResponse);
				socket.addEventListener(SecurityErrorEvent.SECURITY_ERROR, onLoadSecurityError);			
			}
			catch(e:*)
			{
				onError(e);
			}
			
		}
		
		public function send(str:String):void
		{
			if (!ready)	return;
			//trace("sending:",str);
			socket.writeUTFBytes(str);	
			socket.flush();
		}

		private function onConnect(e:Event):void
	 	{
			trace('connected');
			ready = true;
			dispatchEvent( new DataEvent(CONNECTED_TO_SERVER) );
			//send(first_message);
		}
		
		private function onClose(e:Event):void
		{
		    trace('closed');
		    ready = false;
		    dispatchEvent( new DataEvent(DISCONNECTED) );
		}
		
		private function onError(e:*):void
		{
		   trace('connection error:', e.toString() );
		   socket = null;
		   ready = false;
		   dispatchEvent(new Event(CONNECTION_ERROR));
		}
		
		private function onResponse(e:ProgressEvent):void
		{
			var str:String = socket.readUTFBytes( socket.bytesAvailable );
			trace('server msg: ' + str);
			dispatchEvent(new DataEvent(SERVER_MSG,false,false,str));
		}	
		
		private function onLoadSecurityError(e:*):void
		{
			trace ("Error in loader: ", e.toString());
			if (e is SecurityError || e is SecurityErrorEvent )
			{
				trace("\n\nATTENTION: Security Error ***************************+");
				trace("If you are coding the app, remember to add the folder to the flash settings manager:");
				trace("http://www.macromedia.com/support/documentation/en/flashplayer/help/settings_manager04.html"); 
				trace("Otherwise you cant load files from the harddrive");
				trace("\n");
			}		
			dispatchEvent(new Event(CONNECTION_ERROR));
		}			
	}
}