package
{
	import caurina.transitions.*;
	
	import org.flixel.FlxG;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxText;
	import World.World;

	public class MenuState extends FlxState
	{
		public var w:World = null;
		[Embed(source='assets/imgs/imageintro.png')] private var ImgIntro:Class;
		
		private var intro:FlxSprite = null;

		private	var title_txt:FlxText = null; 		
		private	var by_txt:FlxText = null; 		
		private	var txt:FlxText = null; 		
				
        override public function MenuState():void
		{
			intro = new FlxSprite(0,0);
			intro.loadGraphic(ImgIntro);
			intro.y = -intro.frameHeight + 100;
			add(intro);

			title_txt = new FlxText(0, 0, FlxG.width, "In the city...\nno one can hear you scream")
			title_txt.setFormat(null,12,0x334466,"left")
			title_txt.alpha = 0;
			this.add(title_txt);

			by_txt = new FlxText(60, 34, FlxG.width, "by The Beauty & the Geeks")
			by_txt.setFormat(null,8,0xffffff,"left")
			by_txt.alpha = 0.0;
			this.add(by_txt);
			
			txt = new FlxText(0, FlxG.height - 20, FlxG.width, "PRESS X TO START");
			txt.alpha = 0;
			txt.setFormat(null, 8, 0xFFFFFFFF, "center");
			this.add(txt);
			
            FlxG.flash.start(0xffffffff, 0.75);
            
            Tweener.addTween(intro, {time:7,y:0,transition:"easeInOutCubic"});
            Tweener.addTween(title_txt, {time:8,alpha:1,transition:"easeInOutSine"});
            Tweener.addTween(by_txt, {time:9,alpha:0.8,transition:"easeInOutSine"});
            Tweener.addTween(txt, {time:10,alpha:1,transition:"easeInOutCubic"});
        }
        
        override public function update():void
        {
        	
        	
            if (FlxG.keys.pressed("X"))
            {
                FlxG.flash.start(0xffffffff, 0.75);
                FlxG.fade.start(0xff000000, 1, onFade);
            }
            super.update();
        }
        
        private function onFade():void
        {
			FlxG.state = new PlayState();
        }

	}
}