package
{
	import flash.events.DataEvent;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.net.Socket;
	import flash.system.Security;
	import flash.utils.Dictionary;	
	import World.World;
	import World.Character;
	
	public class Server extends EventDispatcher
	{
		public var socket:MySocket = null;
		static public var inst:Server = null;
		
		public var buffer:String = "";
		public var on_error:Function = null;
		
		public function Server()
		{
			inst = this;
		}
		
		public function connectToServer(e:Event=null):void
		{
			trace("waiting...");		
			socket = new MySocket();
			socket.allowServer(gamejam.vars["ip"]);
			socket.addEventListener( MySocket.CONNECTED_TO_SERVER, onServerEvent );
			socket.addEventListener( MySocket.SERVER_MSG, onServerEvent );
			socket.addEventListener( MySocket.DISCONNECTED, onServerEvent );
			socket.addEventListener( MySocket.CONNECTION_ERROR, function(e:Event):void{ if (on_error != null) on_error(); } );
			//server.connect('localhost',50000);
			socket.connect( gamejam.vars["ip"],parseInt(gamejam.vars["port"]));
			//socket.connect( "147.83.79.198",4000);
			GameLogic._mode = "connecting";
			
			/*
			t = new Timer(200);
			t.addEventListener( TimerEvent.TIMER, sendPlayerStatus );
			t.start();
			*/
		}	
		
		public function start():void
		{
			trace("SERVER ERROR");
		}
		
		public function onServerEvent(e:DataEvent):void
		{
			var _p:Character = World.World._player;
			if (e.type == MySocket.CONNECTED_TO_SERVER)
			{
				/*
				_p.createPersonality();
				socket.send(_p._name + "|" + _p._shape.toString());
				World.inst.mode = "waiting";
				*/
			}
			
			else if (e.type == MySocket.SERVER_MSG)
			{
				var data:String = "";
				buffer += e.data;
				var pos:int = 0;
				
				while(true)
				{
					pos = buffer.indexOf("$");
					if (pos == -1) return;
					data = buffer.substr(0,pos);
					buffer = buffer.substr(pos+1);
					processMessage(data);
				}
			}
			else if (e.type == MySocket.DISCONNECTED)
			{
				trace("disconnected");
			}
			else
				trace("¿?")
					
				//trace ("MSG: ",e.data);
				/*
				//first msg
				if (_player == null)
				{
					var a:Array = e.data.split(' ');
					if (a[0] == 'ID')
						start(a[1]);
				}
				else
				{
					if (e.data == '')
					{
						trace("disconnected");
						return;
					}
					
					var a:Array = e.data.split(' ');
					var id:int = a[0];
					if (a[1] == 'BYE')
						deletePerson(a[0]);
					else if (a[1] == 'UPDATE')
					{
						var p:Person = Person.getPerson(id);
						if (p == null)
							createPerson(id,false,e.data);
						else
							updatePerson(id,e.data);
					}
					else
						trace("UNKNOWN: " + e.data);
				}
				*/
		}		
		
		private function processMessage(data:String):void
		{
			if (GameLogic._mode == "waiting")
			{
				//World.inst.initFromServer(data);
				GameLogic._mode = "ready";
			}
			else if (GameLogic._mode == "ready")
			{
				/*
				trace("stats:",data);
				var a:Array = data.split("|");
				if (a[0]=="2") //server status
				{
					var p:Person = World.inst.getOrCreatePerson(a[1]);
					if (p.ready == false)
						p.loadType("anna",a.length > 7 ? a[7] : 1);
					p.unserialize(data);
				}
				*/
			}
			else
				trace("foo");
		}	
		
		public function send(str:String):void
		{
			if (socket && socket.ready)
				socket.send(str + "$");
		}

	}
}